%This Example for using users m-function Optimization_subroutine.m was created automatically by PSG Toolbox.

%Function description:

%minimize
%300 * meansquare(matrix_ab6_dbl)
%20000 * linear(matrix_card2048_dbl)
%Box: >= parameter_bound, <= parameter_bound_1
%Solver: precision = parameter_precision, timelimit = 3600
%
%Value:
%meanabs_pen(matrix_ab6_dbl)
%cardn_pos(parameter_alpha,matrix_card2048_dbl)
%cardn_pos(parameter_alpha_1,matrix_card2048_dbl)
%cardn_pos(parameter_alpha_2,matrix_card2048_dbl)
%cardn_pos(parameter_alpha_3,matrix_card2048_dbl)
%cardn_pos(parameter_alpha_4,matrix_card2048_dbl)
%cardn_pos(parameter_alpha_5,matrix_card2048_dbl)
%max_comp_pos(matrix_card2048_dbl)
%
%Input variables:
%
%Inputs                           PSG Type    PSG Object             Location in Problem Statement                                Class
%matrix_ab6_dbl_benchmark         bench       matrix_ab6_dbl         300 * meansquare(matrix_ab6_dbl)                             double
%                                                                    meanabs_pen(matrix_ab6_dbl)
%matrix_ab6_dbl_data              data        matrix_ab6_dbl         300 * meansquare(matrix_ab6_dbl)                             double
%                                                                    meanabs_pen(matrix_ab6_dbl)
%matrix_ab6_dbl_vars              vars        matrix_ab6_dbl         300 * meansquare(matrix_ab6_dbl)                             cell
%                                                                    meanabs_pen(matrix_ab6_dbl)
%matrix_card2048_dbl_benchmark    bench       matrix_card2048_dbl    20000 * linear(matrix_card2048_dbl)                          double
%                                                                    cardn_pos(parameter_alpha,matrix_card2048_dbl)
%                                                                    cardn_pos(parameter_alpha_1,matrix_card2048_dbl)
%                                                                    cardn_pos(parameter_alpha_2,matrix_card2048_dbl)
%                                                                    cardn_pos(parameter_alpha_3,matrix_card2048_dbl)
%                                                                    cardn_pos(parameter_alpha_4,matrix_card2048_dbl)
%                                                                    cardn_pos(parameter_alpha_5,matrix_card2048_dbl)
%                                                                    max_comp_pos(matrix_card2048_dbl)
%matrix_card2048_dbl_data         data        matrix_card2048_dbl    20000 * linear(matrix_card2048_dbl)                          double
%                                                                    cardn_pos(parameter_alpha,matrix_card2048_dbl)
%                                                                    cardn_pos(parameter_alpha_1,matrix_card2048_dbl)
%                                                                    cardn_pos(parameter_alpha_2,matrix_card2048_dbl)
%                                                                    cardn_pos(parameter_alpha_3,matrix_card2048_dbl)
%                                                                    cardn_pos(parameter_alpha_4,matrix_card2048_dbl)
%                                                                    cardn_pos(parameter_alpha_5,matrix_card2048_dbl)
%                                                                    max_comp_pos(matrix_card2048_dbl)
%matrix_card2048_dbl_vars         vars        matrix_card2048_dbl    20000 * linear(matrix_card2048_dbl)                          cell
%                                                                    cardn_pos(parameter_alpha,matrix_card2048_dbl)
%                                                                    cardn_pos(parameter_alpha_1,matrix_card2048_dbl)
%                                                                    cardn_pos(parameter_alpha_2,matrix_card2048_dbl)
%                                                                    cardn_pos(parameter_alpha_3,matrix_card2048_dbl)
%                                                                    cardn_pos(parameter_alpha_4,matrix_card2048_dbl)
%                                                                    cardn_pos(parameter_alpha_5,matrix_card2048_dbl)
%                                                                    max_comp_pos(matrix_card2048_dbl)
%parameter_bound_data             data        parameter_bound        Box: >= parameter_bound, <= parameter_bound_1                double
%parameter_bound_1_data           data        parameter_bound_1      Box: >= parameter_bound, <= parameter_bound_1                double
%parameter_precision_data         data        parameter_precision    Solver: precision = parameter_precision, timelimit = 3600    char
%parameter_alpha_data             data        parameter_alpha        cardn_pos(parameter_alpha,matrix_card2048_dbl)               double
%parameter_alpha_1_data           data        parameter_alpha_1      cardn_pos(parameter_alpha_1,matrix_card2048_dbl)             double
%parameter_alpha_2_data           data        parameter_alpha_2      cardn_pos(parameter_alpha_2,matrix_card2048_dbl)             double
%parameter_alpha_3_data           data        parameter_alpha_3      cardn_pos(parameter_alpha_3,matrix_card2048_dbl)             double
%parameter_alpha_4_data           data        parameter_alpha_4      cardn_pos(parameter_alpha_4,matrix_card2048_dbl)             double
%parameter_alpha_5_data           data        parameter_alpha_5      cardn_pos(parameter_alpha_5,matrix_card2048_dbl)             double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


%Load data from mat-file:
load('D:\American Optimal Decisions\PSG\MATLAB_Stan\All\Sparse Reconstruction Problems from SPARCO Toolbox\problem_6_L2_dbl_20000\Optimization_subroutine_data.mat')

%Save variables from mat-file to Workspace:
tbpsg_export_to_workspace(toolboxstruc_arr)

%Run users m-function Optimization_subroutine:

[solution_str,outargstruc_arr] = Optimization_subroutine(matrix_ab6_dbl_benchmark,matrix_ab6_dbl_data,matrix_ab6_dbl_vars,matrix_card2048_dbl_benchmark,matrix_card2048_dbl_data,matrix_card2048_dbl_vars,parameter_bound_data,parameter_bound_1_data,parameter_precision_data,parameter_alpha_data,parameter_alpha_1_data,parameter_alpha_2_data,parameter_alpha_3_data,parameter_alpha_4_data,parameter_alpha_5_data);

%Extract Objective:
val_obj = tbpsg_objective(solution_str, outargstruc_arr);

disp(' ');
disp('Objective = ');
disp(val_obj);

%Extract optimal solution:
point_data = tbpsg_optimal_point_data(solution_str, outargstruc_arr);

disp(' ');
disp('Optimal point = ');
disp(point_data);

%Extract structure containing PSG solution reports:
output_structure = tbpsg_solution_struct(solution_str, outargstruc_arr);

disp(' ');
disp('Structure with PSG solution = ');
disp(output_structure);

%Uncomment the following lines to extract solutions details:

%output = tbpsg_isoptimal(solution_str, outargstruc_arr);

%output = tbpsg_function_data(solution_str, outargstruc_arr);

%output = tbpsg_function_names(solution_str, outargstruc_arr);

%output = tbpsg_time(solution_str, outargstruc_arr);

%output = tbpsg_optimal_point_vars(solution_str, outargstruc_arr);

%output = tbpsg_constraints_vars(solution_str, outargstruc_arr);

%output = tbpsg_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_constraint_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_vars(solution_str, outargstruc_arr);

%output = tbpsg_vector_data(solution_str, outargstruc_arr);

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 
